import{S as Ki,i as Qi,s as Xi,e as r,k as u,w as oi,t as a,M as Yi,c as o,d as t,m as f,a as n,x as ai,h as s,b as c,N as et,G as i,g as h,y as si,L as Zi,q as ni,o as li,B as hi,v as er}from"../../chunks/vendor-hf-doc-builder.js";import{I as ci}from"../../chunks/IconCopyLink-hf-doc-builder.js";function tr(ui){let g,_e,v,b,X,A,tt,Y,it,be,B,rt,Ee,E,Z,G,ot,at,ee,M,st,xe,y,x,te,O,nt,ie,lt,Te,U,ht,ke,p,ct,re,ut,ft,oe,dt,pt,Re,m,mt,ae,wt,gt,se,vt,yt,Pe,T,W,fi,_t,ne,bt,Se,d,Et,C,xt,Tt,le,kt,Rt,he,Pt,St,$e,D,di,Ne,k,$t,ce,Nt,Lt,Le,_,R,ue,j,It,fe,At,Ie,P,Gt,de,Mt,Ot,Ae,z,pe,Ct,Dt,Ge,S,jt,me,zt,qt,Me,$,Ht,we,Ft,Bt,Oe,q,pi,Ce,N,Ut,ge,Wt,Vt,De,V,Jt,je,H,mi,ze,L,Kt,ve,Qt,Xt,qe,w,Yt,ye,Zt,ei,F,ti,ii,He;return A=new ci({}),O=new ci({}),j=new ci({}),{c(){g=r("meta"),_e=u(),v=r("h1"),b=r("a"),X=r("span"),oi(A.$$.fragment),tt=u(),Y=r("span"),it=a("(Optional) What is curiosity in Deep Reinforcement Learning?"),be=u(),B=r("p"),rt=a("This is an (optional) introduction about curiosity. If you want to learn more you can read my two articles where I dive into the mathematical details:"),Ee=u(),E=r("ul"),Z=r("li"),G=r("a"),ot=a("Curiosity-Driven Learning through Next State Prediction"),at=u(),ee=r("li"),M=r("a"),st=a("Random Network Distillation: a new take on Curiosity-Driven Learning"),xe=u(),y=r("h2"),x=r("a"),te=r("span"),oi(O.$$.fragment),nt=u(),ie=r("span"),lt=a("Two Major Problems in Modern RL"),Te=u(),U=r("p"),ht=a("To understand what is curiosity, we need first to understand the two major problems with RL:"),ke=u(),p=r("p"),ct=a("First, the "),re=r("em"),ut=a("sparse rewards problem:"),ft=a(" that is, "),oe=r("strong"),dt=a("most rewards do not contain information, and hence are set to zero"),pt=a("."),Re=u(),m=r("p"),mt=a("Remember that RL is based on the "),ae=r("em"),wt=a("reward hypothesis"),gt=a(", which is the idea that each goal can be described as the maximization of the rewards. Therefore, rewards act as feedback for RL agents, "),se=r("strong"),vt=a("if they don\u2019t receive any, their knowledge of which action is appropriate (or not) cannot change"),yt=a("."),Pe=u(),T=r("figure"),W=r("img"),_t=u(),ne=r("figcaption"),bt=a("Source: Thanks to the reward, our agent knows that this action at that state was good"),Se=u(),d=r("p"),Et=a("For instance, in "),C=r("a"),xt=a("Vizdoom"),Tt=a(", a set of environments based on the game Doom \u201CDoomMyWayHome,\u201D your agent is only rewarded "),le=r("strong"),kt=a("if it finds the vest"),Rt=a(`.
However, the vest is far away from your starting point, so most of your rewards will be zero. Therefore, if our agent does not receive useful feedback (dense rewards), it will take much longer to learn an optimal policy and `),he=r("strong"),Pt=a("it can spend time turning around without finding the goal"),St=a("."),$e=u(),D=r("img"),Ne=u(),k=r("p"),$t=a("The second big problem is that "),ce=r("strong"),Nt=a("the extrinsic reward function is handmade, that is in each environment, a human has to implement a reward function"),Lt=a(". But how we can scale that in big and complex environments?"),Le=u(),_=r("h2"),R=r("a"),ue=r("span"),oi(j.$$.fragment),It=u(),fe=r("span"),At=a("So what is curiosity?"),Ie=u(),P=r("p"),Gt=a("A solution to these problems is "),de=r("strong"),Mt=a("to develop a reward function that is intrinsic to the agent, i.e., generated by the agent itself"),Ot=a(". The agent will act as a self-learner since it will be the student, but also its own feedback master."),Ae=u(),z=r("p"),pe=r("strong"),Ct=a("This intrinsic reward mechanism is known as curiosity"),Dt=a(" because this reward push to explore states that are novel/unfamiliar. In order to achieve that, our agent will receive a high reward when exploring new trajectories."),Ge=u(),S=r("p"),jt=a("This reward is in fact designed on how human acts, "),me=r("strong"),zt=a("we have naturally an intrinsic desire to explore environments and discover new things"),qt=a("."),Me=u(),$=r("p"),Ht=a("There are different ways to calculate this intrinsic reward, the classical one (curiosity through next-state prediction) was to calculate curiosity "),we=r("strong"),Ft=a("as the error of our agent of predicting the next state, given the current state and action taken"),Bt=a("."),Oe=u(),q=r("img"),Ce=u(),N=r("p"),Ut=a("Because the idea of curiosity is to "),ge=r("strong"),Wt=a("encourage our agent to perform actions that reduce the uncertainty in the agent\u2019s ability to predict the consequences of its own actions"),Vt=a(" (uncertainty will be higher in areas where the agent has spent less time, or in areas with complex dynamics)."),De=u(),V=r("p"),Jt=a("If the agent spend a lot of times on these states, it will be good to predict the next state (low curiosity), on the other hand, if it\u2019s a new state unexplored, it will be bad to predict the next state (high curiosity)."),je=u(),H=r("img"),ze=u(),L=r("p"),Kt=a("Using curiosity will push our agent to favor transitions with high prediction error (which will be higher in areas where the agent has spent less time, or in areas with complex dynamics) and "),ve=r("strong"),Qt=a("consequently better explore our environment"),Xt=a("."),qe=u(),w=r("p"),Yt=a("There\u2019s also "),ye=r("strong"),Zt=a("other curiosity calculation methods"),ei=a(". ML-Agents uses a more advanced one called Curiosity through random network distillation. This is out of the scope of the tutorial but if you\u2019re interested "),F=r("a"),ti=a("I wrote an article explaining it in detail"),ii=a("."),this.h()},l(e){const l=Yi('[data-svelte="svelte-1phssyn"]',document.head);g=o(l,"META",{name:!0,content:!0}),l.forEach(t),_e=f(e),v=o(e,"H1",{class:!0});var Fe=n(v);b=o(Fe,"A",{id:!0,class:!0,href:!0});var wi=n(b);X=o(wi,"SPAN",{});var gi=n(X);ai(A.$$.fragment,gi),gi.forEach(t),wi.forEach(t),tt=f(Fe),Y=o(Fe,"SPAN",{});var vi=n(Y);it=s(vi,"(Optional) What is curiosity in Deep Reinforcement Learning?"),vi.forEach(t),Fe.forEach(t),be=f(e),B=o(e,"P",{});var yi=n(B);rt=s(yi,"This is an (optional) introduction about curiosity. If you want to learn more you can read my two articles where I dive into the mathematical details:"),yi.forEach(t),Ee=f(e),E=o(e,"UL",{});var Be=n(E);Z=o(Be,"LI",{});var _i=n(Z);G=o(_i,"A",{href:!0,rel:!0});var bi=n(G);ot=s(bi,"Curiosity-Driven Learning through Next State Prediction"),bi.forEach(t),_i.forEach(t),at=f(Be),ee=o(Be,"LI",{});var Ei=n(ee);M=o(Ei,"A",{href:!0,rel:!0});var xi=n(M);st=s(xi,"Random Network Distillation: a new take on Curiosity-Driven Learning"),xi.forEach(t),Ei.forEach(t),Be.forEach(t),xe=f(e),y=o(e,"H2",{class:!0});var Ue=n(y);x=o(Ue,"A",{id:!0,class:!0,href:!0});var Ti=n(x);te=o(Ti,"SPAN",{});var ki=n(te);ai(O.$$.fragment,ki),ki.forEach(t),Ti.forEach(t),nt=f(Ue),ie=o(Ue,"SPAN",{});var Ri=n(ie);lt=s(Ri,"Two Major Problems in Modern RL"),Ri.forEach(t),Ue.forEach(t),Te=f(e),U=o(e,"P",{});var Pi=n(U);ht=s(Pi,"To understand what is curiosity, we need first to understand the two major problems with RL:"),Pi.forEach(t),ke=f(e),p=o(e,"P",{});var J=n(p);ct=s(J,"First, the "),re=o(J,"EM",{});var Si=n(re);ut=s(Si,"sparse rewards problem:"),Si.forEach(t),ft=s(J," that is, "),oe=o(J,"STRONG",{});var $i=n(oe);dt=s($i,"most rewards do not contain information, and hence are set to zero"),$i.forEach(t),pt=s(J,"."),J.forEach(t),Re=f(e),m=o(e,"P",{});var K=n(m);mt=s(K,"Remember that RL is based on the "),ae=o(K,"EM",{});var Ni=n(ae);wt=s(Ni,"reward hypothesis"),Ni.forEach(t),gt=s(K,", which is the idea that each goal can be described as the maximization of the rewards. Therefore, rewards act as feedback for RL agents, "),se=o(K,"STRONG",{});var Li=n(se);vt=s(Li,"if they don\u2019t receive any, their knowledge of which action is appropriate (or not) cannot change"),Li.forEach(t),yt=s(K,"."),K.forEach(t),Pe=f(e),T=o(e,"FIGURE",{});var We=n(T);W=o(We,"IMG",{src:!0,alt:!0}),_t=f(We),ne=o(We,"FIGCAPTION",{});var Ii=n(ne);bt=s(Ii,"Source: Thanks to the reward, our agent knows that this action at that state was good"),Ii.forEach(t),We.forEach(t),Se=f(e),d=o(e,"P",{});var I=n(d);Et=s(I,"For instance, in "),C=o(I,"A",{href:!0,rel:!0});var Ai=n(C);xt=s(Ai,"Vizdoom"),Ai.forEach(t),Tt=s(I,", a set of environments based on the game Doom \u201CDoomMyWayHome,\u201D your agent is only rewarded "),le=o(I,"STRONG",{});var Gi=n(le);kt=s(Gi,"if it finds the vest"),Gi.forEach(t),Rt=s(I,`.
However, the vest is far away from your starting point, so most of your rewards will be zero. Therefore, if our agent does not receive useful feedback (dense rewards), it will take much longer to learn an optimal policy and `),he=o(I,"STRONG",{});var Mi=n(he);Pt=s(Mi,"it can spend time turning around without finding the goal"),Mi.forEach(t),St=s(I,"."),I.forEach(t),$e=f(e),D=o(e,"IMG",{src:!0,alt:!0}),Ne=f(e),k=o(e,"P",{});var Ve=n(k);$t=s(Ve,"The second big problem is that "),ce=o(Ve,"STRONG",{});var Oi=n(ce);Nt=s(Oi,"the extrinsic reward function is handmade, that is in each environment, a human has to implement a reward function"),Oi.forEach(t),Lt=s(Ve,". But how we can scale that in big and complex environments?"),Ve.forEach(t),Le=f(e),_=o(e,"H2",{class:!0});var Je=n(_);R=o(Je,"A",{id:!0,class:!0,href:!0});var Ci=n(R);ue=o(Ci,"SPAN",{});var Di=n(ue);ai(j.$$.fragment,Di),Di.forEach(t),Ci.forEach(t),It=f(Je),fe=o(Je,"SPAN",{});var ji=n(fe);At=s(ji,"So what is curiosity?"),ji.forEach(t),Je.forEach(t),Ie=f(e),P=o(e,"P",{});var Ke=n(P);Gt=s(Ke,"A solution to these problems is "),de=o(Ke,"STRONG",{});var zi=n(de);Mt=s(zi,"to develop a reward function that is intrinsic to the agent, i.e., generated by the agent itself"),zi.forEach(t),Ot=s(Ke,". The agent will act as a self-learner since it will be the student, but also its own feedback master."),Ke.forEach(t),Ae=f(e),z=o(e,"P",{});var ri=n(z);pe=o(ri,"STRONG",{});var qi=n(pe);Ct=s(qi,"This intrinsic reward mechanism is known as curiosity"),qi.forEach(t),Dt=s(ri," because this reward push to explore states that are novel/unfamiliar. In order to achieve that, our agent will receive a high reward when exploring new trajectories."),ri.forEach(t),Ge=f(e),S=o(e,"P",{});var Qe=n(S);jt=s(Qe,"This reward is in fact designed on how human acts, "),me=o(Qe,"STRONG",{});var Hi=n(me);zt=s(Hi,"we have naturally an intrinsic desire to explore environments and discover new things"),Hi.forEach(t),qt=s(Qe,"."),Qe.forEach(t),Me=f(e),$=o(e,"P",{});var Xe=n($);Ht=s(Xe,"There are different ways to calculate this intrinsic reward, the classical one (curiosity through next-state prediction) was to calculate curiosity "),we=o(Xe,"STRONG",{});var Fi=n(we);Ft=s(Fi,"as the error of our agent of predicting the next state, given the current state and action taken"),Fi.forEach(t),Bt=s(Xe,"."),Xe.forEach(t),Oe=f(e),q=o(e,"IMG",{src:!0,alt:!0}),Ce=f(e),N=o(e,"P",{});var Ye=n(N);Ut=s(Ye,"Because the idea of curiosity is to "),ge=o(Ye,"STRONG",{});var Bi=n(ge);Wt=s(Bi,"encourage our agent to perform actions that reduce the uncertainty in the agent\u2019s ability to predict the consequences of its own actions"),Bi.forEach(t),Vt=s(Ye," (uncertainty will be higher in areas where the agent has spent less time, or in areas with complex dynamics)."),Ye.forEach(t),De=f(e),V=o(e,"P",{});var Ui=n(V);Jt=s(Ui,"If the agent spend a lot of times on these states, it will be good to predict the next state (low curiosity), on the other hand, if it\u2019s a new state unexplored, it will be bad to predict the next state (high curiosity)."),Ui.forEach(t),je=f(e),H=o(e,"IMG",{src:!0,alt:!0}),ze=f(e),L=o(e,"P",{});var Ze=n(L);Kt=s(Ze,"Using curiosity will push our agent to favor transitions with high prediction error (which will be higher in areas where the agent has spent less time, or in areas with complex dynamics) and "),ve=o(Ze,"STRONG",{});var Wi=n(ve);Qt=s(Wi,"consequently better explore our environment"),Wi.forEach(t),Xt=s(Ze,"."),Ze.forEach(t),qe=f(e),w=o(e,"P",{});var Q=n(w);Yt=s(Q,"There\u2019s also "),ye=o(Q,"STRONG",{});var Vi=n(ye);Zt=s(Vi,"other curiosity calculation methods"),Vi.forEach(t),ei=s(Q,". ML-Agents uses a more advanced one called Curiosity through random network distillation. This is out of the scope of the tutorial but if you\u2019re interested "),F=o(Q,"A",{href:!0,rel:!0});var Ji=n(F);ti=s(Ji,"I wrote an article explaining it in detail"),Ji.forEach(t),ii=s(Q,"."),Q.forEach(t),this.h()},h(){c(g,"name","hf:doc:metadata"),c(g,"content",JSON.stringify(ir)),c(b,"id","optional-what-is-curiosity-in-deep-reinforcement-learning"),c(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(b,"href","#optional-what-is-curiosity-in-deep-reinforcement-learning"),c(v,"class","relative group"),c(G,"href","https://medium.com/data-from-the-trenches/curiosity-driven-learning-through-next-state-prediction-f7f4e2f592fa"),c(G,"rel","nofollow"),c(M,"href","https://medium.com/data-from-the-trenches/curiosity-driven-learning-through-random-network-distillation-488ffd8e5938"),c(M,"rel","nofollow"),c(x,"id","two-major-problems-in-modern-rl"),c(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(x,"href","#two-major-problems-in-modern-rl"),c(y,"class","relative group"),et(W.src,fi="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/curiosity1.png")||c(W,"src",fi),c(W,"alt","Curiosity"),c(C,"href","https://vizdoom.cs.put.edu.pl/"),c(C,"rel","nofollow"),et(D.src,di="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/curiosity2.png")||c(D,"src",di),c(D,"alt","Curiosity"),c(R,"id","so-what-is-curiosity"),c(R,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(R,"href","#so-what-is-curiosity"),c(_,"class","relative group"),et(q.src,pi="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/curiosity3.png")||c(q,"src",pi),c(q,"alt","Curiosity"),et(H.src,mi="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/curiosity4.png")||c(H,"src",mi),c(H,"alt","Curiosity"),c(F,"href","https://medium.com/data-from-the-trenches/curiosity-driven-learning-through-random-network-distillation-488ffd8e5938"),c(F,"rel","nofollow")},m(e,l){i(document.head,g),h(e,_e,l),h(e,v,l),i(v,b),i(b,X),si(A,X,null),i(v,tt),i(v,Y),i(Y,it),h(e,be,l),h(e,B,l),i(B,rt),h(e,Ee,l),h(e,E,l),i(E,Z),i(Z,G),i(G,ot),i(E,at),i(E,ee),i(ee,M),i(M,st),h(e,xe,l),h(e,y,l),i(y,x),i(x,te),si(O,te,null),i(y,nt),i(y,ie),i(ie,lt),h(e,Te,l),h(e,U,l),i(U,ht),h(e,ke,l),h(e,p,l),i(p,ct),i(p,re),i(re,ut),i(p,ft),i(p,oe),i(oe,dt),i(p,pt),h(e,Re,l),h(e,m,l),i(m,mt),i(m,ae),i(ae,wt),i(m,gt),i(m,se),i(se,vt),i(m,yt),h(e,Pe,l),h(e,T,l),i(T,W),i(T,_t),i(T,ne),i(ne,bt),h(e,Se,l),h(e,d,l),i(d,Et),i(d,C),i(C,xt),i(d,Tt),i(d,le),i(le,kt),i(d,Rt),i(d,he),i(he,Pt),i(d,St),h(e,$e,l),h(e,D,l),h(e,Ne,l),h(e,k,l),i(k,$t),i(k,ce),i(ce,Nt),i(k,Lt),h(e,Le,l),h(e,_,l),i(_,R),i(R,ue),si(j,ue,null),i(_,It),i(_,fe),i(fe,At),h(e,Ie,l),h(e,P,l),i(P,Gt),i(P,de),i(de,Mt),i(P,Ot),h(e,Ae,l),h(e,z,l),i(z,pe),i(pe,Ct),i(z,Dt),h(e,Ge,l),h(e,S,l),i(S,jt),i(S,me),i(me,zt),i(S,qt),h(e,Me,l),h(e,$,l),i($,Ht),i($,we),i(we,Ft),i($,Bt),h(e,Oe,l),h(e,q,l),h(e,Ce,l),h(e,N,l),i(N,Ut),i(N,ge),i(ge,Wt),i(N,Vt),h(e,De,l),h(e,V,l),i(V,Jt),h(e,je,l),h(e,H,l),h(e,ze,l),h(e,L,l),i(L,Kt),i(L,ve),i(ve,Qt),i(L,Xt),h(e,qe,l),h(e,w,l),i(w,Yt),i(w,ye),i(ye,Zt),i(w,ei),i(w,F),i(F,ti),i(w,ii),He=!0},p:Zi,i(e){He||(ni(A.$$.fragment,e),ni(O.$$.fragment,e),ni(j.$$.fragment,e),He=!0)},o(e){li(A.$$.fragment,e),li(O.$$.fragment,e),li(j.$$.fragment,e),He=!1},d(e){t(g),e&&t(_e),e&&t(v),hi(A),e&&t(be),e&&t(B),e&&t(Ee),e&&t(E),e&&t(xe),e&&t(y),hi(O),e&&t(Te),e&&t(U),e&&t(ke),e&&t(p),e&&t(Re),e&&t(m),e&&t(Pe),e&&t(T),e&&t(Se),e&&t(d),e&&t($e),e&&t(D),e&&t(Ne),e&&t(k),e&&t(Le),e&&t(_),hi(j),e&&t(Ie),e&&t(P),e&&t(Ae),e&&t(z),e&&t(Ge),e&&t(S),e&&t(Me),e&&t($),e&&t(Oe),e&&t(q),e&&t(Ce),e&&t(N),e&&t(De),e&&t(V),e&&t(je),e&&t(H),e&&t(ze),e&&t(L),e&&t(qe),e&&t(w)}}}const ir={local:"optional-what-is-curiosity-in-deep-reinforcement-learning",sections:[{local:"two-major-problems-in-modern-rl",title:"Two Major Problems in Modern RL"},{local:"so-what-is-curiosity",title:"So what is curiosity?"}],title:"(Optional) What is curiosity in Deep Reinforcement Learning?"};function rr(ui){return er(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class sr extends Ki{constructor(g){super();Qi(this,g,rr,tr,Xi,{})}}export{sr as default,ir as metadata};
